#! /usr/bin/wish -f

# AVRConfig pre0.1
#
# this program should help you configuring you libraries...
# 
# released under GPL by Johann Wilhelm oe6jwf
#

global VarList
global Var2ModulMapper

global Notices
global AvailableModules

set AvailableModules ""
set Notices ""

# Sets an Variable Value
proc SetVariableValue {var value} {
	global VarList
	set  VarList($var) $value
}


# Registers a Variable ...
# returns 0 if a variable has been used more than once else returns 1
proc RegisterVariable {modul var} {
	global VarList
	global Notices
	global Var2ModulMapper
	if {[lsearch [array names VarList] $var]!=-1} {
		set Notices [linsert $Notices end "// notice: $var is used more than one time"]
		set  Var2ModulMapper($var) [linsert $Var2ModulMapper($var) end $modul]		
		return 0
	} else {
		set  VarList($var) ""
		set  Var2ModulMapper($var) ""
		set  Var2ModulMapper($var) [linsert $Var2ModulMapper($var) end $modul]
		return 1
	}
}

# make window

frame .mainframe -width 10c -height 5c
wm title . "AVRConfig pre1 0.1"
pack .mainframe

frame .edf 

text .ed -width 80 -height 20 -bg grey \
-yscrollcommand ".ys set" 

scrollbar .ys -command ".ed yview" 
pack .ed .ys -in .edf -side left -fill y

frame .menubar -relief raised -bd 2
pack .menubar -in .mainframe -fill x
pack .edf -in .mainframe -after .menubar -fill x


# make menu

menubutton .menubar.file -text File -underline 0 -menu .menubar.file.menu
menu .menubar.file.menu
.menubar.file.menu add command -label "Save" -command { Save }

menubutton .menubar.modules -text Modules -menu .menubar.modules.menu
pack .menubar.file .menubar.modules -side left
menu .menubar.modules.menu 
.menubar.modules.menu add command -label "Select Modules" -command { ShowModulSelect }
.menubar.modules.menu add separator


# include modules and execute init-functions
cd modules
set modules [glob *]
foreach module $modules {
	source $module
	set AvailableModules [linsert $AvailableModules end $module]
	$module\_init
	set $module\_selected 0
}

cd ..

proc Save {} {
	global VarList
	global Var2ModulMapper
	
	global Notices
	global AvailableModules
	
	#sort the modules...
	set AvailableModules [lsort $AvailableModules]

	# output the configured variables

	set configfile [open "config.h" w+]

	puts $configfile "/* This file was produced by AVRConfig 0.1 */\n"
	foreach  notice $Notices {
		puts $configfile $notice
	}
	
	# output variables used in multible modules...
	puts $configfile "\n/* following variables or used in more than one module */"
	foreach  var [lsort [array names Var2ModulMapper]] {
		if ([llength $Var2ModulMapper($var)]>1) {
			puts $configfile "\n// used by $Var2ModulMapper($var)"
			puts $configfile "#define $var $VarList($var)"
		}
	}

	puts $configfile "\n/* Modul Configuration */"

	foreach  modul $AvailableModules {
		global $modul\_selected
		puts $configfile ""
		if ($$modul\_selected==1) {
			puts $configfile "// Modul $modul"
			foreach var [lsort [array names VarList]] {
				if ([array size $Var2ModulMapper($var)]<=1) {
					if ([lsearch $Var2ModulMapper($var) $modul]!=-1) {
						puts $configfile "#define $var $VarList($var)"
					}
				}
			}
		}
	}
	close $configfile

}

proc ShowModulSelect {} {
	global VarList
	global Notices
	global ChoosenModules
	global AvailableModules

	toplevel .modulselect -width 250 -height 240
	grab .modulselect
	wm title .modulselect "Modul Selector"
	set y 6

	foreach modul $AvailableModules {
		global $modul\_selected
		checkbutton .modulselect.[string tolower $modul] -text "$modul" -variable $modul\_selected
		place .modulselect.[string tolower $modul] -in .modulselect -x 2 -y $y
		set y [expr {$y+20}]
	}
	
	button .modulselect.ok -text "OK" -command {ModulSelect_OK} -width 10
	place .modulselect.ok -in .modulselect -x 6 -y [expr {$y+10}]

	button .modulselect.cancel -text "Cancel" -command {destroy .modulselect} -width 10
	place .modulselect.cancel -in .modulselect -x 150 -y [expr {$y+10}]
	
	.modulselect  configure -height [expr {$y+50}] 
	focus .modulselect	
}

proc ModulSelect_OK {} {
	global AvailableModules 
	.menubar.modules.menu delete 1 end
	.menubar.modules.menu add command -label "Select Modules" -command { ShowModulSelect }
	.menubar.modules.menu add separator
	
	foreach modul $AvailableModules {
		global $modul\_selected
		if ($$modul\_selected==1) {
			$modul\_AddMenu
		}
	}
	destroy .modulselect
}